Mount and unmount /dev/pts for chrooting (issue #39)
[grml-debootstrap.git] / grml-debootstrap
1 #!/bin/bash
2 # Filename:      grml-debootstrap
3 # Purpose:       wrapper around debootstrap for installing plain Debian via Grml
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2+
7 ################################################################################
8
9 # variables {{{
10 PN="$(basename "$0")"
11 if [[ -d "$(dirname "$(which "$0")")"/.git ]]; then
12   VERSION="$(git describe | sed 's|^v||')"
13 else
14   VERSION="$(dpkg-query --show --showformat='${Version}' "$PN")"
15 fi
16 VERSION="${VERSION:-unknown}"
17 MNTPOINT="/mnt/debootstrap.$$"
18
19 # defaults
20 [ -n "$CHROOT_SCRIPTS" ] || CHROOT_SCRIPTS='yes'
21 [ -n "$CONFFILES" ] || CONFFILES='/etc/debootstrap'
22 [ -n "$DEBCONF" ] || DEBCONF='yes'
23 [ -n "$DEBIAN_FRONTEND" ] || DEBIAN_FRONTEND='noninteractive'
24 [ -n "$DEBOOTSTRAP" ] || DEBOOTSTRAP='debootstrap'
25 [ -n "$DEFAULT_LANGUAGE" ] || DEFAULT_LANGUAGE='en_US:en'
26 [ -n "$DEFAULT_LOCALES" ] || DEFAULT_LOCALES='en_US.UTF-8'
27 [ -n "$DISK_IDENTIFIER" ] || DISK_IDENTIFIER='26ada0c0-1165-4098-884d-aafd2220c2c6'
28 [ -n "$EXTRAPACKAGES" ] || EXTRAPACKAGES='yes'
29 [ -n "$FALLBACK_MIRROR" ] || FALLBACK_MIRROR='http://http.debian.net/debian'
30 [ -n "$FIXED_DISK_IDENTIFIERS" ] || FIXED_DISK_IDENTIFIERS="no"
31 [ -n "$FORCE" ] || FORCE=''
32 [ -n "$HOSTNAME" ] || HOSTNAME='grml'
33 [ -n "$INITRD" ] || INITRD='yes'
34 [ -n "$INSTALL_NOTES" ] || INSTALL_NOTES='/etc/debootstrap/install_notes'
35 [ -n "$LOCALES" ] || LOCALES='yes'
36 [ -n "$MIRROR" ] || MIRROR="$FALLBACK_MIRROR"
37 [ -n "$MKFS" ] || MKFS='mkfs.ext4'
38 [ -n "$MKFS_OPTS" ] || MKFS_OPTS=''
39 [ -n "$PACKAGES" ] || PACKAGES='yes'
40 [ -n "$PRE_SCRIPTS" ] || PRE_SCRIPTS='yes'
41 [ -n "$RECONFIGURE" ] || RECONFIGURE='console-data'
42 [ -n "$RELEASE" ] || RELEASE='jessie'
43 [ -n "$RM_APTCACHE" ] || RM_APTCACHE='yes'
44 [ -n "$SCRIPTS" ] || SCRIPTS='yes'
45 [ -n "$SECURE" ] || SECURE='yes'
46 [ -n "$TIMEZONE" ] || TIMEZONE='Europe/Vienna'
47 [ -n "$TUNE2FS" ] || TUNE2FS='tune2fs -c0 -i0'
48 [ -n "$UPGRADE_SYSTEM" ] || UPGRADE_SYSTEM='yes'
49 [ -n "$VMSIZE" ] || VMSIZE="2G"
50
51 # inside the chroot system locales might not be available, so use minimum:
52 export LANG=C
53 export LC_ALL=C
54
55 # make sure interactive mode is only executed when
56 # using an empty configuration file or option --interactive
57 INTERACTIVE=''
58 # }}}
59
60 # help text {{{
61 usage() {
62   echo "$PN - wrapper around debootstrap for installing Debian
63
64 Usage: $PN [options]
65
66 Bootstrap options:
67
68   -m, --mirror <URL>     Mirror which should be used for apt-get/aptitude.
69   -i, --iso <mnt>        Mountpoint where a Debian ISO is mounted to, for use
70                          instead of fetching packages from a mirror.
71   -r, --release <name>   Release of new Debian system (default: jessie).
72   -t, --target <target>  Target partition (/dev/...) or directory where the
73                          system should be installed to.
74   -p, --mntpoint <mnt>   Mountpoint used for mounting the target system,
75                          has no effect if -t is given and represents a directory.
76       --debopt <params>  Extra parameters passed to the debootstrap command.
77       --interactive      Use interactive mode (frontend).
78       --nodebootstrap    Skip debootstrap, only do configuration to the target.
79       --grub <device>    Target for grub installation. Usage example: /dev/sda
80       --arch <arch>      Set target architecture, use for installing i386 on amd64.
81       --filesystem <fs>  Filesystem that should be used when target is a partition
82                          or Virtual Machine (see --vmfile).
83       --force            Do not prompt for user acknowledgement.
84
85 Options for Virtual Machine deployment:
86
87       --vm               Set up a Virtual Machine, instead of plainly installing
88                          to a partition or directory, to be combined with --target,
89                          like: --vm --target /dev/mapper/your-vm-disk
90       --vmfile           Like --vm, but install into a file (raw format).
91                          Example: --vmfile --target /mnt/sda1/qemu.img
92       --vmsize <size>    Use specified size for size of VM file (default: 2G).
93                          Syntax as supported by qemu-img, like: --vmsize 3G
94
95 Configuration options:
96
97   -c, --config <file>      Use specified configuration file, defaults to
98                              /etc/debootstrap/config
99   -d, --confdir <path>     Place of config files for debootstrap, defaults
100                              to /etc/debootstrap
101       --packages <file>    Install packages defined in specified list file
102                              instead of using /etc/debootstrap/packages.
103       --nopackages         Skip installation of packages defined in
104                              /etc/debootstrap/packages
105       --nokernel           Skip installation of default kernel images.
106       --nointerfaces       Do not copy /etc/network/interfaces from host system
107                            to target system.
108                            (This option is automatically enabled when using --vmfile.)
109       --defaultinterfaces  Install a default /etc/network/interfaces file (enabling
110                            DHCP for eth0) instead of taking over config from host system.
111       --debconf <file>     Pre-seed packages using specified pre-seed db file.
112       --grmlrepos          Enable Grml's Debian repository (deb.grml.org).
113       --backportrepos      Enable Debian's backports repository (backports.debian.org).
114       --keep_src_list      Do not overwrite user provided apt sources.list.
115       --hostname <name>    Hostname of Debian system.
116       --nopassword         Do not prompt for the root password.
117       --password <pwd>     Use specified password as password for user root.
118       --bootappend <line>  Add specified appendline to kernel whilst booting.
119       --chroot-scripts <d> Execute chroot scripts from specified directory.
120       --pre-scripts <dir>  Execute scripts from specified directory (before chroot-scripts).
121       --scripts <dir>      Execute scripts from specified directory (after chroot-scripts).
122
123 Other options:
124
125   -v, --verbose            Increase verbosity.
126       --debug              Execute in very verbose way.
127   -h, --help               Print this usage information and exit.
128   -V, --version            Show summary of options and exit.
129
130 Usage examples can be found in the grml-debootstrap manpage.
131 Send bugreports to the grml-team: bugs (at) grml.org || http://grml.org/bugs/
132 "
133 }
134
135 if [ "$1" = '-h' ] || [ "$1" = '-help' ] || [ "$1" = "--help" ] ; then
136    usage
137    echo 'Please notice that this script requires root permissions!'
138    exit 0
139 fi
140 # }}}
141
142 # early helper functions {{{
143 GOOD='\e[32;01m'
144 BAD='\e[31;01m'
145 WARN='\e[33;01m'
146 NORMAL='\e[0m'
147
148 einfo() {
149   einfon "$1\n"
150   return 0
151 }
152
153 einfon() {
154   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
155   printf " ${GOOD}*${NORMAL} $*"
156   LAST_E_CMD=einfon
157   return 0
158 }
159
160 ewarn() {
161   printf " ${WARN}*${NORMAL} $*\n"
162   return 0
163 }
164
165 eerror() {
166   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
167   printf " ${BAD}*${NORMAL} $*\n" >&2
168   LAST_E_CMD=eerror
169   return 0
170 }
171
172 eend() {
173   local retval="${1:-0}"
174   shift
175   if [ "$retval" -gt 0 ]; then
176     printf " ${BAD}-> Failed (rc=${retval})${NORMAL}\n"
177   fi
178   return "$retval"
179 }
180
181 check4root(){
182   if [ "$(id -u 2>/dev/null)" != 0 ] ; then
183     echo 1>&2 "Error: please run this script with uid 0 (root)." ; return 1
184   fi
185 }
186
187 check4progs(){
188   local RC=''
189   for arg in "$@" ; do
190     which "$arg" >/dev/null 2>&1 || RC="$arg"
191   done
192   if [ -n "$RC" ] ; then
193      echo "$RC not installed"
194      return 1
195   fi
196 }
197 # }}}
198
199 # helper functions {{{
200 cleanup() {
201   if [ -n "$CHROOT_VARIABLES" ] ; then
202     einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" ; eend $?
203   fi
204
205   if [ -n "$STAGES" ] ; then
206     einfo "Removing ${STAGES}" ; rmdir "$STAGES" ; eend $?
207   fi
208
209   # Remove temporary mountpoint again
210   if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
211     rmdir "$MNTPOINT" 2>/dev/null
212   fi
213
214   # make sure $TARGET is not mounted when exiting grml-debootstrap
215   if [ -n "$MNTPOINT" ] ; then
216     if grep -q "$MNTPOINT" /proc/mounts ; then
217       # make sure nothing is left inside chroot so we can unmount it
218       for service in ssh mdadm ; do
219         if [ -x "${MNTPOINT}/etc/init.d/${service}" ] ; then
220           chroot "$MNTPOINT" "/etc/init.d/${service}" stop
221         fi
222       done
223
224       [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a >/dev/null 2>&1
225
226       # ugly, but make sure we really don't leave anything (/proc /proc and
227       # /dev /dev are intended, trying to work around timing issues, see #657023)
228       for ARG in /sys /proc /proc /dev/pts /dev/pts /dev /dev ; do
229         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1
230         umount "$MNTPOINT"/$ARG >/dev/null 2>&1
231       done
232
233       if [ -n "$ISODIR" ] ; then
234         [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" >/dev/null 2>&1
235       fi
236
237       if [ -n "$DIRECTORY" ] ; then
238         einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice." ; eend 0
239       else
240         einfo "Unmounting $MNTPOINT"
241         umount "$MNTPOINT"
242         eend $?
243       fi
244
245       if [ -n "$STAGES" ] ; then
246         echo -n "Removing stages directory ${STAGES}: "
247         rm -rf "$STAGES" && echo 'done'
248       fi
249
250       # remove directory only if we used the default with process id inside the name
251       if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
252         einfo "Removing directory ${MNTPOINT}"
253         rmdir "$MNTPOINT"
254         eend $?
255       fi
256     fi
257   fi
258
259   if [ -n "${ORIG_TARGET}" ] ; then
260     einfo "Removing loopback mount of file ${ORIG_TARGET}."
261     kpartx -d "${ORIG_TARGET}" ; eend $?
262   fi
263 }
264
265 # we want to exit smoothly and clean:
266 bailout(){
267
268   cleanup
269
270   [ -n "$1" ] && EXIT="$1" || EXIT="1"
271   [ -n "$2" ] && einfo "Notice: remove $STAGES/$2 to reexecute the stage"
272
273   exit "$EXIT"
274 }
275 trap bailout HUP INT QUIT TERM
276
277 # we want to execute all the functions only once, simple check for it:
278 stage() {
279   if [ -n "$2" ] ; then
280      echo "$2" > "${STAGES}/${1}"
281      return 0
282   elif grep -q 'done' "${STAGES}/${1}" 2>/dev/null ; then
283      ewarn "Notice: stage $1 has been executed already, skipping execution therefore." ; eend 0
284      ewarn "  To reexecute it clean up the according directory inside $STAGES" ; eend 0
285      return 1
286   fi
287 }
288 # }}}
289
290 # make sure we have what we need {{{
291 check4progs debootstrap || bailout 1
292 # }}}
293
294 # source main configuration file {{{
295 if [ -r /etc/debootstrap/config ] ; then
296   . /etc/debootstrap/config
297 fi
298 # }}}
299
300 # cmdline handling {{{
301 # source external command line parameter-processing script
302 self_dir="$(dirname "$(which "$0")")"
303 if [ -r "${self_dir}"/cmdlineopts.clp ] ; then
304    . "${self_dir}"/cmdlineopts.clp
305 elif [ -r /usr/share/grml-debootstrap/functions/cmdlineopts.clp ] ; then
306    . /usr/share/grml-debootstrap/functions/cmdlineopts.clp
307 else
308    eerror "Error: cmdline function file not found, exiting."
309    eend 1
310    bailout 1
311 fi
312
313 # == business-logic of command line parameter-processing
314
315 # source configuration file in <confdir> if supplied. {{{
316 [ "$_opt_confdir" ] && {
317   CONFFILES=$_opt_confdir
318   einfo "Using config files under $CONFFILES/."
319   if ! [ -r "$CONFFILES/config" ] ; then
320     eerror "Error: config file $CONFFILES/config not found."; eend 1; bailout 1
321   fi
322   if ! . "$CONFFILES/config" ; then
323     eerror "Error reading config file $CONFFILES/config" ; eend 1 ; bailout 1
324   fi
325   # restore the command line parameter value
326   CONFFILES=$_opt_confdir
327 }
328 # }}}
329
330 [ "$_opt_mirror" ]              && MIRROR=$_opt_mirror
331 [ "$_opt_iso" ]                 && ISO=$_opt_iso
332 [ "$_opt_release" ]             && RELEASE=$_opt_release
333 [ "$_opt_target" ]              && TARGET=$_opt_target
334 [ "$_opt_vm" ]                  && VIRTUAL=1
335 [ "$_opt_vmfile" ]              && VMFILE=1 && VIRTUAL=1
336 [ "$_opt_vmsize" ]              && VMSIZE=$_opt_vmsize
337 [ "$_opt_mntpoint" ]            && MNTPOINT=$_opt_mntpoint
338 [ "$_opt_debopt" ]              && DEBOOTSTRAP_OPT=$_opt_debopt
339 [ "$_opt_interactive" ]         && INTERACTIVE=1
340 [ "$_opt_config" ]              && CONFIGFILE=$_opt_config
341 [ "$_opt_filesystem" ]          && MKFS="mkfs.$_opt_filesystem"
342 [ "$_opt_packages_set" ]        && PACKAGES='yes'
343 [ "$_opt_nopackages" ]          && PACKAGES=''
344 [ "$_opt_debconf_set" ]         && DEBCONF='yes'
345 [ "$_opt_scripts_set" ]         && SCRIPTS='yes'
346 [ "$_opt_pre_scripts_set" ]     && PRE_SCRIPTS='yes'
347 [ "$_opt_chroot_scripts_set" ]  && CHROOT_SCRIPTS='yes'
348 [ "$_opt_keep_src_list" ]       && KEEP_SRC_LIST='yes'
349 [ "$_opt_grmlrepos" ]           && GRMLREPOS='yes'
350 [ "$_opt_backportrepos" ]       && BACKPORTREPOS='yes'
351 [ "$_opt_hostname" ]            && HOSTNAME=$_opt_hostname
352 [ "$_opt_password" ]            && ROOTPASSWORD=$_opt_password
353 [ "$_opt_nopassword" ]          && NOPASSWORD='yes'
354 [ "$_opt_defaultinterfaces" ]   && USE_DEFAULT_INTERFACES="true"
355 [ "$_opt_nointerfaces" ]        && NOINTERFACES="true"
356 [ "$_opt_nokernel" ]            && NOKERNEL="true"
357 [ "$_opt_bootappend" ]          && BOOT_APPEND=$_opt_bootappend
358 [ "$_opt_grub" ]                && GRUB=$_opt_grub
359 [ "$_opt_arch" ]                && ARCH=$_opt_arch
360 [ "$_opt_insecure" ]            && echo "Warning: --insecure is deprecated, continuing anyway."
361 [ "$_opt_force" ]               && FORCE=$_opt_force
362 [ "$_opt_verbose" ]             && VERBOSE="-v"
363 [ "$_opt_debug" ]               && DEBUG="true"
364
365 if [ "$DEBUG" = "true" ] ; then
366   set -x
367 fi
368
369 [ "$_opt_help" ] && {
370   usage ; eend 0
371   eend 0
372   exit 0
373 }
374
375 [ "$_opt_version" ] && {
376   einfo "$PN - version $VERSION"
377   einfo "Send bug reports to bugs@grml.org or http://grml.org/bugs/"
378   eend 0
379   exit 0
380 }
381 # }}}
382
383 # check for root permissions {{{
384 if ! check4root ; then
385    echo "For usage instructions please execute '$PN --help'."
386    bailout 1
387 fi
388 # }}}
389
390 # make sure we have what we need {{{
391 if [ -n "$VIRTUAL" ] ; then
392   check4progs grub-mkimage kpartx mksh parted qemu-img || bailout 1
393 fi
394 # }}}
395
396 # source specified configuration file {{{
397 if [ -n "$CONFIGFILE" ] ; then
398    einfo "Reading specified config file $CONFIGFILE."
399    if ! . "$CONFIGFILE" ; then
400       eerror "Error reading config file $CONFIGFILE" ; eend 1 ; bailout 1
401    fi
402 fi
403 # }}}
404
405 # backwards compability checks {{{
406 if [ -n "$GROOT" ] ; then
407    eerror "Error: you seem to have \$GROOT configured."
408    eerror "This variable is no longer supported, please visit the"
409    eerror "grml-debootstrap documentation for details."
410    eend 1
411    bailout 1
412 fi
413
414 if echo "$GRUB" | grep -q '^hd' ; then
415    eerror "Error: this syntax for the grub configuration variable is no longer supported."
416    eerror "Please do not use hd... any longer but /dev/sdX instead."
417    eend 1
418    bailout 1
419 fi
420 # }}}
421
422 # welcome screen {{{
423 welcome_dialog()
424 {
425    dialog --title "$PN" --yesno "Welcome to the interactive configuration of ${PN}.
426 Do you want to continue installing Debian using this frontend?" 0 0 || bailout 0
427 }
428 # }}}
429
430 # ask for target {{{
431 prompt_for_target()
432 {
433   AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
434                sed 's/*//' | \
435                grep -v 'Extended$' | \
436                gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}'; ls /dev/md[0-9]* 2>/dev/null || true);
437
438   if [ -z "$AVAILABLE_PARTITIONS" ] ; then
439      dialog --title "$PN" --trim \
440      --msgbox "Sorry, no partitions found. Please configure your
441      harddisks (see /proc/partitions) using a tool like fdisk,
442      cfdisk, gpart, gparted,..." 0 0
443      bailout 1
444   fi
445
446   PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
447                      fs="$(blkid -s TYPE -o value "$i" 2>/dev/null)"
448                      [ -n "$fs" ] || fs='[no_filesystem_yet]'
449                      echo "$i" "$fs"
450                      unset fs
451                    done)
452
453   TARGET=$(dialog --title "$PN" --single-quoted --stdout \
454          --menu "Please select the target partition:" 0 0 0 \
455          $PARTITION_LIST)
456   [ $? -eq 0 ] || bailout 1
457 }
458 # }}}
459
460 # ask for bootmanager {{{
461 prompt_for_bootmanager()
462 {
463   ADDITIONAL_PARAMS=""
464
465   if echo "$TARGET" | grep -q "/dev/md" ; then
466      MBRPART="all disks of Software RAID $TARGET"
467   else
468      # figure out whole disk device
469      found=
470      for device in /dev/disk/by-id/*
471      do
472         [ "$(readlink -f "$device")" = "${TARGET}" ] || continue
473         found=1
474         break
475      done
476      [ -n "$found" ] && MBRDISK=$(echo "${device}" |sed -e 's/-part[0-9][0-9]*$//')
477      if [ -e "$MBRDISK" ]; then
478         MBRDISK=$(readlink -f "$MBRDISK")
479      else
480         # fall back to old behaviour
481         MBRDISK=$(echo "${TARGET}" | sed -e 's/[0-9][0-9]*$//')
482      fi
483
484      MBRPART="MBR of $MBRDISK"
485   fi
486
487   for device in cciss/c0d0 sda hda; do
488     if [ "/dev/$device" != "${MBRDISK}" ]; then
489       grep -q $device /proc/partitions && \
490       ADDITIONAL_PARAMS="$ADDITIONAL_PARAMS:$device:install bootmanager grub into MBR of /dev/$device"
491     fi
492   done
493   ADDITIONAL_PARAMS=${ADDITIONAL_PARAMS#:}
494
495   OIFS="$IFS"; IFS=:
496
497   GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
498           --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
499             mbr       "install bootmanager into $MBRPART" \
500             nowhere   "do not install bootmanager at all" \
501           ${ADDITIONAL_PARAMS})
502   [ $? -eq 0 ] || bailout 3
503   IFS="$OIFS"
504
505   case "$GETMBR" in
506     mbr)
507       # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
508       if echo "$TARGET" | grep -q "/dev/md" ; then
509         GRUB="$TARGET"
510       else
511         GRUB="$MBRDISK"
512       fi
513       ;;
514     hda)
515       GRUB="/dev/hda"
516       ;;
517     sda)
518       GRUB="/dev/sda"
519       ;;
520     nowhere)
521       GRUB=''
522       ;;
523   esac
524 }
525 # }}}
526
527 # ask for Debian release {{{
528 prompt_for_release()
529 {
530   [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='jessie'
531   RELEASE="$(dialog --stdout --title "${PN}" --default-item $DEFAULT_RELEASE --menu \
532             "Please enter the Debian release you would like to use for installation:" \
533             0 50 5 \
534             lenny    Debian/5.0 \
535             squeeze  Debian/6.0 \
536             wheezy   Debian/7.0 \
537             jessie   Debian/8.0 \
538             sid      Debian/unstable)"
539   [ $? -eq 0 ] || bailout
540 }
541 # }}}
542
543 # ask for hostname {{{
544 prompt_for_hostname()
545 {
546   HOSTNAME="$(dialog --stdout --title "${PN}" --inputbox \
547             "Please enter the hostname you would like to use for installation:" \
548             0 0 "$HOSTNAME")"
549   [ $? -eq 0 ] || bailout
550 }
551 # }}}
552
553 # ask for password {{{
554 prompt_for_password()
555 {
556   if [ "$_opt_nopassword" ] ; then
557     einfo "Skip asking for root password as requested."
558     return 0
559   fi
560
561   ROOTPW1='PW1'
562   ROOTPW2='PW2'
563   while [ "$ROOTPW1" != "$ROOTPW2" ]; do
564     ROOTPW1=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
565     "Please enter the password for the root account:" 10 60)
566     [ $? -eq 0 ] || bailout
567
568     ROOTPW2=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
569     "Please enter the password for the root account again for \
570     confirmation:" 10 60)
571     [ $? -eq 0 ] || bailout
572
573     if [ "$ROOTPW1" != "$ROOTPW2" ]; then
574       dialog --stdout --title "${PN}" --ok-label \
575         "Retry" --msgbox "Passwords do not match!" 10 60
576     fi
577   done
578   ROOTPASSWORD="$ROOTPW1"
579 }
580 # }}}
581
582 # ask for Debian mirror {{{
583 prompt_for_mirror()
584 {
585   [ -n "$ISO" ] && DEFAULT_MIRROR='local' || DEFAULT_MIRROR='net'
586
587   CHOOSE_MIRROR=$(dialog --stdout --title "$PN" --default-item $DEFAULT_MIRROR \
588           --menu "Where do you want to install from?" 0 0 0 \
589             net   "install via network (downloading from mirror)" \
590             local "install from local directory/mirror"
591           )
592   [ $? -eq 0 ] || bailout
593
594   if [ "$CHOOSE_MIRROR" = 'net' ] ; then
595      [ -n "$MIRROR" ] || MIRROR='http://http.debian.net/debian'
596      MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
597                "Please enter Debian mirror you would like to use for installing packages." \
598                0 0 $MIRROR)"
599      [ $? -eq 0 ] || bailout
600   else # CHOOSE_MIRROR == local
601      [ -n "$ISO" ] || ISO='/mnt/mirror'
602      ISO="$(dialog --stdout --title "${PN}" --inputbox \
603                "Please enter directory name you would like to use for installing packages." \
604                0 0 $ISO)"
605      [ $? -eq 0 ] || bailout
606   fi
607 }
608 # }}}
609
610 # software raid setup {{{
611 config_swraid_setup()
612 {
613 TMPFILE=$(mktemp)
614
615 # Currently we support only raid1:
616 RAIDLEVEL='raid1'
617
618 MD_LIST=$(for i in $(seq 0 9) ; do
619             awk '{print $4}' /proc/partitions | grep -q "md$i" || \
620             echo "/dev/md$i /dev/md$i"
621           done)
622
623 TARGET=$(dialog --stdout --title "$PN" --default-item /dev/md0 \
624 --menu "Which device do you want to use for ${RAIDLEVEL}?
625
626 Notice: activated devices will not be listed for security reasons. Anyway, please make sure the selected device is not in use already!" 0 0 0 \
627 $MD_LIST)
628 [ $? -eq 0 ] || bailout 20
629
630 AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
631              sed 's/*//' | \
632              grep -v 'Extended$' | \
633              gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
634 [ -n "$AVAILABLE_PARTITIONS" ] || echo "Fatal error: no partitions available?"
635 PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
636                      echo "$i $(blkid -s TYPE -o value "$i" 2>/dev/null || echo '[no_filesystem_yet]') off"
637                  done)
638
639 dialog --title "$PN" --separate-output \
640        --checklist "Please select the partitions you would like to use for your $RAIDLEVEL on ${TARGET}:" 0 0 0 \
641        $PARTITION_LIST 2>"$TMPFILE"
642 [ $? -eq 0 ] || bailout
643 SELECTED_PARTITIONS="$(cat "$TMPFILE")"
644
645 NUM_PARTITIONS=0
646 for i in $(cat "$TMPFILE") ; do
647    NUM_PARTITIONS=$(( NUM_PARTITIONS + 1 ))
648 done
649
650 # force metadata version 0.90 for lenny so old grub can boot from this array.
651 METADATA_VERSION=""
652 if [ "$RELEASE" = "lenny" ]; then
653    METADATA_VERSION="-e0"
654 fi
655
656 ERRORFILE=$(mktemp)
657 yes | mdadm --create "${TARGET}" --level="${RAIDLEVEL}" \
658       --raid-devices="${NUM_PARTITIONS}" ${METADATA_VERSION} ${SELECTED_PARTITIONS} >/dev/null 2>$ERRORFILE
659 RC=$?
660 if [ "$RC" = 0 ] ; then
661    dialog --title "$PN" --msgbox \
662    "Creating $TARGET was successful." 0 0
663    rm -f "$TMPFILE" "$ERRORFILE"
664 else
665    dialog --title "$PN" --msgbox \
666    "There was an error setting up $TARGET:
667
668 $(cat "$ERRORFILE")
669
670 Exiting." 0 0
671    rm -f "$TMPFILE" "$ERRORFILE"
672    bailout 1
673 fi
674
675 }
676
677 prompt_for_swraid()
678 {
679 if dialog --stdout --title "$PN" \
680           --defaultno --yesno "Do you want to configure Software RAID?
681
682 Please notice that only RAID level 1 is supported by ${PN} currently. Configuration will take place using mdadm." 0 0 ; then
683   config_swraid_setup
684 fi
685 }
686 # }}}
687
688 # user should recheck his configuration {{{
689 # support full automatic installation:
690 checkforrun() {
691    dialog --timeout 10 --title "$PN" \
692           --yesno "Do you want to stop at this stage?
693
694 Notice: you are running ${PN} in non-interactive mode.
695 ${PN} will install Debian ${RELEASE} on ${TARGET}.
696 Last chance to quit. Timeout of 10 seconds running....
697
698 Do you want to stop now?" 0 0 2>/dev/null
699 }
700 # }}}
701
702 # make sure the user is aware of the used configuration {{{
703 checkconfiguration()
704 {
705 if [ -n "$AUTOINSTALL" ] ; then
706    if checkforrun ; then
707       eerror "Exiting as requested" ; eend 0
708       bailout 1
709    fi
710 elif [ -n "$INTERACTIVE" ] ; then
711
712    INFOTEXT="Please recheck configuration before execution:
713    "
714    [ -n "$TARGET" ]  && INFOTEXT="$INFOTEXT
715    Target:          $TARGET"
716    [ -n "$GRUB" ]    && INFOTEXT="$INFOTEXT
717    Install grub:    $GRUB"
718    [ -n "$RELEASE" ] && INFOTEXT="$INFOTEXT
719    Using release:   $RELEASE"
720    [ -n "$HOSTNAME" ] && INFOTEXT="$INFOTEXT
721    Using hostname:  $HOSTNAME"
722    [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
723    Using mirror:    $MIRROR"
724    [ -n "$ISO" ]  && INFOTEXT="$INFOTEXT
725    Using ISO:       $ISO"
726    [ -n "$ARCH" ]  && INFOTEXT="$INFOTEXT
727    Using arch:      $ARCH"
728
729    INFOTEXT="$INFOTEXT
730
731 Is this ok for you? Notice: selecting 'No' will exit ${PN}."
732
733    dialog --title "$PN" --no-collapse \
734           --yesno "$INFOTEXT" 0 0
735    [ $? -eq 0 ] || bailout 0
736
737 else # if not running automatic installation display configuration and prompt for execution:
738    einfo "$PN [${VERSION}] - Please recheck configuration before execution:"
739    echo
740    echo "   Target:          $TARGET"
741
742    # do not display if MNTPOINT is the default one
743    case "$MNTPOINT" in /mnt/debootstrap*) ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
744
745    if [ -n "$VIRTUAL" ] ; then
746       echo "   Install grub:    yes"
747    else
748      [ -n "$GRUB" ]     && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
749    fi
750
751    [ -n "$RELEASE" ]  && echo "   Using release:   $RELEASE"
752    [ -n "$HOSTNAME" ] && echo "   Using hostname:  $HOSTNAME"
753    [ -n "$MIRROR" ]   && echo "   Using mirror:    $MIRROR"
754    [ -n "$ISO" ]      && echo "   Using ISO:       $ISO"
755    [ -n "$ARCH" ]     && echo "   Using arch:      $ARCH"
756    if [ -n "$VIRTUAL" ] ; then
757       echo "   Deploying as Virtual Machine."
758       if [ -n "$VMSIZE" -a -n "$VMFILE" ]; then
759          echo "   Using Virtual Disk file with size of ${VMSIZE}."
760       fi
761    fi
762
763    if [ ! -t 0 -a -z "$ROOTPASSWORD" -a -z "$NOPASSWORD" ] ; then
764       echo
765       echo "   You do not have a TTY allocated, your password will be shown in"
766       echo "   plaintext on the terminal! If you are using SSH, try its -t option!"
767    fi
768
769    echo
770    echo "   Important! Continuing will delete all data from ${TARGET}!"
771
772    if [ -n "$FORCE" ] ; then
773      einfo "Skip user acknowledgement as requested via --force option."
774    else
775      echo
776      einfon "Is this ok for you? [y/N] "
777      read a
778      if ! [ "$a" = 'y' -o "$a" = 'Y' ] ; then
779         eerror "Exiting as requested." ; eend 1
780         bailout 1
781      fi
782    fi
783 fi
784 }
785 # }}}
786
787 # interactive mode {{{
788 interactive_mode()
789 {
790   check4progs dialog || bailout 1
791
792   welcome_dialog
793
794   prompt_for_release
795
796   prompt_for_swraid
797
798   prompt_for_target
799
800   prompt_for_bootmanager
801
802   prompt_for_hostname
803
804   prompt_for_password
805
806   prompt_for_mirror
807 }
808
809 # run interactive mode if we didn't get the according configuration yet
810 if [ -z "$TARGET" -o -n "$INTERACTIVE" ] ; then
811    # only target might be unset, so make sure the INTERACTIVE flag is set as well
812    INTERACTIVE=1
813    interactive_mode
814 fi
815 # }}}
816
817 # architecture setup {{{
818 if [ -n "$ARCH" ] ; then
819    ARCHCMD="--arch $ARCH"
820    ARCHINFO=" (${ARCH})"
821 else
822    ARCH="$(dpkg --print-architecture)"
823    ARCHCMD="--arch $ARCH"
824    ARCHINFO=" (${ARCH})"
825 fi
826 # }}}
827
828 # It is not possible to build amd64 on i686. {{{
829 CURRENT_ARCH="$(uname -m)"
830 if [ "$CURRENT_ARCH" != "x86_64" ] ; then
831    if [ "$ARCH" = "amd64" ] ; then
832       eerror "It is not possible to build amd64 on $CURRENT_ARCH." ; eend 1
833       bailout 1
834    fi
835 fi
836 # }}}
837
838 # Support for generic release codenames is unavailable. {{{
839 if [ "$RELEASE" = "stable" ] || [ "$RELEASE" = "testing" ] ; then
840    eerror "Generic release codenames (stable, testing) are unsupported. \
841 Please use specific codenames such as lenny, squeeze, wheezy or jessie." ; eend 1
842    bailout 1
843 fi
844 # }}}
845
846 checkconfiguration
847
848 # finally make sure at least $TARGET is set [the partition for the new system] {{{
849 if [ -n "$TARGET" ] ; then
850    SHORT_TARGET="${TARGET##*/}"
851 else
852    eerror "Please adjust $CONFFILES/config or..."
853    eerror "... use the interactive version for configuration before running ${0}" ; eend 1
854    bailout 1
855 fi
856 # }}}
857
858 # stages setup {{{
859 if [ -z "$STAGES" ] ; then
860    STAGES="/var/cache/grml-debootstrap/stages_${SHORT_TARGET}"
861    [ -d "$STAGES" ] || mkdir -p "$STAGES"
862 fi
863
864 if [ -r "$STAGES"/grml-debootstrap ] ; then
865    if grep -q 'done' "${STAGES}/grml-debootstrap" ; then
866       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
867       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}" ; eend 1
868    fi
869 fi
870 # }}}
871
872 # partition handling {{{
873 PARTITION=''
874 DIRECTORY=''
875
876 set_target_directory(){
877     # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
878     DIRECTORY=1
879     MNTPOINT="$TARGET"
880     MKFS=''
881     TUNE2FS=''
882     FSCK=''
883     # make sure we normalise the path to an absolute directory name so something like:
884     #  mkdir -p foo/a bar/a; (cd foo; grml-debootstrap -t a)&; (cd bar; grml-debootstrap -t a)&; wait
885     # works
886     TARGET="$(readlink -f "$TARGET")"
887 }
888
889 if [ -b "$TARGET" ] || [ -n "$VIRTUAL" ] ; then
890     PARTITION=1
891 else
892     set_target_directory
893 fi
894 # }}}
895
896 # make sure we have the right syntax when using an iso image {{{
897 if [ -n "$ISO" ] ; then
898    case $ISO in
899       file*) # do nothing
900       ;;
901       *)
902       ISO=file:$ISO
903       ;;
904    esac
905 fi
906 ISODIR=${ISO##file:}
907 ISODIR=${ISODIR%%/}
908 # }}}
909
910 # Debian ISOs do not contain signed Release files {{{
911 if [ -n "$ISO" ] ; then
912     DEBOOTSTRAP_OPT="$DEBOOTSTRAP_OPT --no-check-gpg"
913 fi
914 # }}}
915
916 # create filesystem {{{
917 mkfs() {
918   if [ -n "$DIRECTORY" ] ; then
919      einfo "Running grml-debootstrap on a directory, skipping mkfs stage."
920      return 0
921   fi
922
923   if grep -q "$TARGET" /proc/mounts ; then
924     eerror "$TARGET already mounted, exiting to avoid possible damage. (Manually unmount $TARGET)" ; eend 1
925     bailout 1
926   fi
927
928   # mkfs.ext* might prompt with "/dev/sdX# contains a ext* file system
929   # created on ... Proceed anyway? (y,n)" which we want to skip in force mode
930   if [ -n "$MKFS" ] && [ -n "$FORCE" ] ; then
931     case "$MKFS" in
932       mkfs.ext*)
933         einfo "Enabling force option (-F) for mkfs.ext* tool as requested via --force switch."
934         MKFS_OPTS="$MKFS_OPTS -F"
935         eend 0
936         ;;
937     esac
938   fi
939
940   if [ -n "$MKFS" ] ; then
941     einfo "Running $MKFS $MKFS_OPTS on $TARGET"
942     "$MKFS" $MKFS_OPTS "$TARGET" ; RC=$?
943
944     if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
945       if ! echo "$MKFS" | grep -q "mkfs.ext" ; then
946         eerror "Not changing disk uuid for $TARGET because $MKFS doesn't seem to match for ext{2,3,4} file system"
947         eend 1
948         bailout 1
949       else
950         einfo "Changing disk uuid for $TARGET to fixed (non-random) value $DISK_IDENTIFIER using tune2fs"
951         tune2fs "$TARGET" -U "$DISK_IDENTIFIER"
952         eend $?
953       fi
954     fi
955
956     # make sure /dev/disk/by-uuid/... is up2date, otherwise grub
957     # will fail to detect the uuid in the chroot
958     if echo "$TARGET" | grep -q "/dev/md" ; then
959       blockdev --rereadpt "${TARGET}"
960     elif ! [ -n "$VIRTUAL" ] ; then
961       blockdev --rereadpt "${TARGET%%[0-9]*}"
962     fi
963     # give the system 2 seconds, otherwise we might run into
964     # race conditions :-/
965     sleep 2
966
967     eval "$(blkid -o udev "$TARGET" 2>/dev/null)"
968     [ -n "$ID_FS_UUID" ] && TARGET_UUID="$ID_FS_UUID" || TARGET_UUID=""
969
970     eend $RC
971   fi
972 }
973 # }}}
974
975 # modify filesystem settings {{{
976 tunefs() {
977   if [ -n "$TUNE2FS" ] && echo "$MKFS" | grep -q "mkfs.ext" ; then
978      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
979      $TUNE2FS "$TARGET"
980      eend $?
981   fi
982 }
983 # }}}
984
985 # mount the new partition or if it's a directory do nothing at all {{{
986 mount_target() {
987   if [ -n "$DIRECTORY" ] ; then
988      einfo "Running grml-debootstrap on a directory, nothing to mount."
989   else
990      if grep -q "$TARGET" /proc/mounts ; then
991         ewarn "$TARGET already mounted, continuing anyway." ; eend 0
992      else
993        if ! [ -d "${MNTPOINT}" ] ; then
994           [ -n "$VIRTUAL" ] || mkdir -p "${MNTPOINT}"
995        fi
996        einfo "Mounting $TARGET to $MNTPOINT"
997        mkdir -p "$MNTPOINT"
998        mount -o rw,suid,dev "$TARGET" "$MNTPOINT"
999        eend $?
1000      fi
1001   fi
1002   if [ -n "$ISODIR" ] ; then
1003      einfo "Mounting Debian image loopback to $MNTPOINT/$ISODIR."
1004      mkdir -p "$MNTPOINT/$ISODIR"
1005      mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
1006      eend $?
1007   fi
1008 }
1009 # }}}
1010
1011 # prepare VM image for usage with debootstrap {{{
1012 prepare_vm() {
1013   if [ -z "$VIRTUAL" ] ; then
1014      return 0 # be quiet by intention
1015   fi
1016
1017   if [ -b "$TARGET" -a -n "$VMFILE" ] ; then
1018      eerror "Error: specified virtual disk target ($TARGET) is an existing block device."
1019      eend 1
1020      bailout 1
1021   fi
1022   if [ ! -b "$TARGET" -a -z "$VMFILE" ] ; then
1023      eerror "Error: specified virtual disk target ($TARGET) does not exist yet."
1024      eend 1
1025      bailout 1
1026   fi
1027
1028   ORIG_TARGET="$TARGET" # store for later reuse
1029
1030   if [ -n "$VMFILE" ]; then
1031     qemu-img create -f raw "${TARGET}" "${VMSIZE}"
1032   fi
1033   echo 4 66 | /usr/share/grml-debootstrap/bootgrub.mksh -A | dd of="$TARGET" conv=notrunc
1034   dd if=/dev/zero bs=1 conv=notrunc count=64 seek=446 of="$TARGET"
1035   if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1036     einfo "Adjusting disk signature to a fixed (non-random) value"
1037     MBRTMPFILE=$(mktemp)
1038     dd if="${TARGET}" of="${MBRTMPFILE}" bs=512 count=1
1039     echo -en "\x41\x41\x41\x41\x41" | dd of="${MBRTMPFILE}" conv=notrunc seek=440 bs=1
1040     dd if="${MBRTMPFILE}" of="${TARGET}" conv=notrunc
1041     eend $?
1042   fi
1043   parted -s "${TARGET}" 'mkpart primary ext4 2M -1'
1044
1045   # if dm-mod isn't available then kpartx will fail with
1046   # "Is device-mapper driver missing from kernel? [...]"
1047   if ! kpartx -av "$TARGET" >/dev/null 2>&1 || ! grep -q 'device-mapper' /proc/misc >/dev/null 2>&1 ; then
1048     einfo "Device-mapper not ready yet, trying to load dm-mod module."
1049     modprobe dm-mod ; eend $?
1050   fi
1051
1052   # make sure loop module is present
1053   if ! losetup -f >/dev/null 2>&1; then
1054     einfo "Can not find a usable loop device, retrying after loading loop module."
1055     modprobe loop
1056     if losetup -f >/dev/null 2>&1; then
1057       einfo "Found a usable loop device now, continuing."
1058     else
1059       eerror "Error finding usable loop device" ; eend 1
1060       bailout 1
1061     fi
1062   fi
1063
1064   DEVINFO=$(kpartx -asv "$TARGET") # 'add map loop1p1 (253:0): 0 6289408 linear /dev/loop1 2048'
1065   if [ -z "${DEVINFO}" ] ; then
1066     eerror "Error setting up loopback device." ; eend 1
1067     bailout 1
1068   fi
1069
1070   # hopefully this always works as expected
1071   LOOP=$(echo "${DEVINFO}" | sed 's/.* linear //; s/ [[:digit:]]*//') # 'loop1'
1072   LOOP_PART="$(echo "${DEVINFO##add map }" | sed 's/ .*//')" # 'loop1p1'
1073   export TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop1p1'
1074
1075   blockdev --rereadpt "${LOOP}"
1076
1077   if [ -z "$TARGET" ] ; then
1078      eerror "Error: target could not be set to according /dev/mapper/* device." ; eend 1
1079      bailout 1
1080   fi
1081 }
1082 # }}}
1083
1084 # make VM image bootable and unmount it {{{
1085 finalize_vm() {
1086   if [ -z "${VIRTUAL}" ] ; then
1087      return 0
1088   fi
1089
1090   if ! mount "${TARGET}" "${MNTPOINT}" ; then
1091     eerror "Error: Mounting ${TARGET} failed, can not continue." ; eend 1
1092     bailout 1
1093   fi
1094
1095   einfo "Installing Grub as bootloader."
1096   mount -t proc none "${MNTPOINT}"/proc
1097   mount -t sysfs none "${MNTPOINT}"/sys
1098   mount --bind /dev "${MNTPOINT}"/dev
1099   mount --bind /dev/pts "${MNTPOINT}"/dev/pts
1100
1101   mkdir -p "${MNTPOINT}/boot/grub"
1102   if ! [ -d "${MNTPOINT}"/usr/lib/grub/i386-pc/ ] ; then
1103      eerror "Error: grub not installed inside Virtual Machine. Can not install bootloader." ; eend 1
1104      bailout 1
1105   fi
1106
1107   case "$RELEASE" in
1108     lenny|squeeze|wheezy)
1109       cp "${MNTPOINT}"/usr/lib/grub/i386-pc/* "${MNTPOINT}/boot/grub/"
1110       ;;
1111     *)
1112       cp -a "${MNTPOINT}"/usr/lib/grub/i386-pc "${MNTPOINT}/boot/grub/"
1113       ;;
1114   esac
1115   chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos ext2
1116   dd if="${MNTPOINT}/tmp/core.img" of="${ORIG_TARGET}" conv=notrunc seek=4
1117   rm -f "${MNTPOINT}/tmp/core.img"
1118
1119   einfo "Updating grub configuration file."
1120   if [ -n "$BOOT_APPEND" ] ; then
1121      sed -i "/GRUB_CMDLINE_LINUX_DEFAULT/ s#\"\$# ${BOOT_APPEND}\"#" "${MNTPOINT}"/etc/default/grub
1122   fi
1123   chroot "${MNTPOINT}" update-grub
1124
1125   case "$RELEASE" in
1126     lenny|squeeze|wheezy)
1127       einfo "Adjusting grub.cfg for successful boot sequence."
1128       sed -i "s;root=[^ ]\+;root=UUID=$TARGET_UUID;" "${MNTPOINT}"/boot/grub/grub.cfg
1129       ;;
1130   esac
1131
1132   umount "${MNTPOINT}"/proc
1133   umount "${MNTPOINT}"/sys
1134   umount "${MNTPOINT}"/dev/pts
1135   umount "${MNTPOINT}"/dev
1136   umount "${MNTPOINT}"
1137   kpartx -d "${ORIG_TARGET}" >/dev/null
1138 }
1139 # }}}
1140
1141 # install main chroot {{{
1142 debootstrap_system() {
1143   if [ "$_opt_nodebootstrap" ]; then
1144      einfo "Skipping debootstrap as requested."
1145      return
1146   fi
1147
1148   if grep -q "$MNTPOINT" /proc/mounts || [ -n "$DIRECTORY" ] ; then
1149     :
1150   else
1151     eerror "Error: $MNTPOINT not mounted, can not continue."
1152     eend 1 ; exit 1
1153   fi
1154
1155   if [ -n "$ISO" ] ; then
1156     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${ISO}"
1157     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO"
1158     "$DEBOOTSTRAP" $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$ISO"
1159     RC=$?
1160   else
1161     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}"
1162     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR"
1163     "$DEBOOTSTRAP" $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$MIRROR"
1164     RC=$?
1165   fi
1166
1167   if [ $RC -ne 0 ] ; then
1168     if [ -r "$MNTPOINT/debootstrap/debootstrap.log" ] && \
1169       [ -s "$MNTPOINT/debootstrap/debootstrap.log" ] ; then
1170       einfo "Presenting last ten lines of debootstrap.log:"
1171       tail -10 "${MNTPOINT}"/debootstrap/debootstrap.log
1172       einfo "End of debootstrap.log"
1173     fi
1174   fi
1175
1176   eend $RC
1177 }
1178 # }}}
1179
1180 # prepare chroot via chroot-script {{{
1181 preparechroot() {
1182   einfo "Preparing chroot system"
1183
1184   # provide variables to chroot system
1185   CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
1186   touch "$CHROOT_VARIABLES"
1187   chmod 600 "$CHROOT_VARIABLES" # make sure nobody except root can read it
1188   echo "# Configuration of ${PN}"                                                                                   > "$CHROOT_VARIABLES"
1189   # Resorting to sed(1) for escaping since "VAR='${VAR//\'/\'\\\'\'}'" does not work with all versions of Bash,
1190   #   e.g. not with 4.2.37(1)-release (a.k.a 4.2+dfsg-0.1+deb7u3) of Debian wheezy
1191   [ -n "$ARCH" ]                && echo "ARCH='$(sed "s,','\\\\'',g" <<<"${ARCH}")'"                               >> "$CHROOT_VARIABLES"
1192   [ -n "$BACKPORTREPOS" ]       && echo "BACKPORTREPOS='$(sed "s,','\\\\'',g" <<<"${BACKPORTREPOS}")'"             >> "$CHROOT_VARIABLES"
1193   [ -n "$CHROOT_SCRIPTS" ]      && echo "CHROOT_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${CHROOT_SCRIPTS}")'"           >> "$CHROOT_VARIABLES"
1194   [ -n "$CONFFILES" ]           && echo "CONFFILES='$(sed "s,','\\\\'',g" <<<"${CONFFILES}")'"                     >> "$CHROOT_VARIABLES"
1195   [ -n "$DEBCONF" ]             && echo "DEBCONF='$(sed "s,','\\\\'',g" <<<"${DEBCONF}")'"                         >> "$CHROOT_VARIABLES"
1196   [ -n "$DEBIAN_FRONTEND" ]     && echo "DEBIAN_FRONTEND='$(sed "s,','\\\\'',g" <<<"${DEBIAN_FRONTEND}")'"         >> "$CHROOT_VARIABLES"
1197   [ -n "$DEBOOTSTRAP" ]         && echo "DEBOOTSTRAP='$(sed "s,','\\\\'',g" <<<"${DEBOOTSTRAP}")'"                 >> "$CHROOT_VARIABLES"
1198   [ -n "$DEFAULT_LOCALES" ]     && echo "DEFAULT_LOCALES='$(sed "s,','\\\\'',g" <<<"${DEFAULT_LOCALES}")'"         >> "$CHROOT_VARIABLES"
1199   [ -n "$DEFAULT_LANGUAGE" ]    && echo "DEFAULT_LANGUAGE='$(sed "s,','\\\\'',g" <<<"${DEFAULT_LANGUAGE}")'"       >> "$CHROOT_VARIABLES"
1200   [ -n "$EXTRAPACKAGES" ]       && echo "EXTRAPACKAGES='$(sed "s,','\\\\'',g" <<<"${EXTRAPACKAGES}")'"             >> "$CHROOT_VARIABLES"
1201   [ -n "$FALLBACK_MIRROR" ]     && echo "FALLBACK_MIRROR='$(sed "s,','\\\\'',g" <<<"${FALLBACK_MIRROR}")'"         >> "$CHROOT_VARIABLES"
1202   [ -n "$FORCE" ]               && echo "FORCE='$(sed "s,','\\\\'',g" <<<"${FORCE}")'"                             >> "$CHROOT_VARIABLES"
1203   [ -n "$GRMLREPOS" ]           && echo "GRMLREPOS='$(sed "s,','\\\\'',g" <<<"${GRMLREPOS}")'"                     >> "$CHROOT_VARIABLES"
1204   [ -n "$GRUB" ]                && echo "GRUB='$(sed "s,','\\\\'',g" <<<"${GRUB}")'"                               >> "$CHROOT_VARIABLES"
1205   [ -n "$HOSTNAME" ]            && echo "HOSTNAME='$(sed "s,','\\\\'',g" <<<"${HOSTNAME}")'"                       >> "$CHROOT_VARIABLES"
1206   [ -n "$INITRD" ]              && echo "INITRD='$(sed "s,','\\\\'',g" <<<"${INITRD}")'"                           >> "$CHROOT_VARIABLES"
1207   [ -n "$INSTALL_NOTES" ]       && echo "INSTALL_NOTES='$(sed "s,','\\\\'',g" <<<"${INSTALL_NOTES}")'"             >> "$CHROOT_VARIABLES"
1208   [ -n "$ISODIR" ]              && echo "ISODIR='$(sed "s,','\\\\'',g" <<<"${ISO}")'"                              >> "$CHROOT_VARIABLES"
1209   [ -n "$ISO" ]                 && echo "ISO='$(sed "s,','\\\\'',g" <<<"${ISO}")'"                                 >> "$CHROOT_VARIABLES"
1210   [ -n "$KEEP_SRC_LIST" ]       && echo "KEEP_SRC_LIST='$(sed "s,','\\\\'',g" <<<"${KEEP_SRC_LIST}")'"             >> "$CHROOT_VARIABLES"
1211   [ -n "$LOCALES" ]             && echo "LOCALES='$(sed "s,','\\\\'',g" <<<"${LOCALES}")'"                         >> "$CHROOT_VARIABLES"
1212   [ -n "$MIRROR" ]              && echo "MIRROR='$(sed "s,','\\\\'',g" <<<"${MIRROR}")'"                           >> "$CHROOT_VARIABLES"
1213   [ -n "$MKFS" ]                && echo "MKFS='$(sed "s,','\\\\'',g" <<<"${MKFS}")'"                               >> "$CHROOT_VARIABLES"
1214   [ -n "$NOPASSWORD" ]          && echo "NOPASSWORD=\"true\""                                                      >> "$CHROOT_VARIABLES"
1215   [ -n "$NOKERNEL" ]            && echo "NOKERNEL=\"true\""                                                        >> "$CHROOT_VARIABLES"
1216   [ -n "$PACKAGES" ]            && echo "PACKAGES='$(sed "s,','\\\\'',g" <<<"${PACKAGES}")'"                       >> "$CHROOT_VARIABLES"
1217   [ -n "$PRE_SCRIPTS" ]         && echo "PRE_SCRIPTS='$(sed "s,','\\\\'',g" <<<"${PRE_SCRIPTS}")'"                 >> "$CHROOT_VARIABLES"
1218   [ -n "$RECONFIGURE" ]         && echo "RECONFIGURE='$(sed "s,','\\\\'',g" <<<"${RECONFIGURE}")'"                 >> "$CHROOT_VARIABLES"
1219   [ -n "$RELEASE" ]             && echo "RELEASE='$(sed "s,','\\\\'',g" <<<"${RELEASE}")'"                         >> "$CHROOT_VARIABLES"
1220   [ -n "$RM_APTCACHE" ]         && echo "RM_APTCACHE='$(sed "s,','\\\\'',g" <<<"${RM_APTCACHE}")'"                 >> "$CHROOT_VARIABLES"
1221   [ -n "$ROOTPASSWORD" ]        && echo "ROOTPASSWORD='$(sed "s,','\\\\'',g" <<<"${ROOTPASSWORD}")'"               >> "$CHROOT_VARIABLES"
1222   [ -n "$SCRIPTS" ]             && echo "SCRIPTS='$(sed "s,','\\\\'',g" <<<"${SCRIPTS}")'"                         >> "$CHROOT_VARIABLES"
1223   [ -n "$SECURE" ]              && echo "SECURE='$(sed "s,','\\\\'',g" <<<"${SECURE}")'"                           >> "$CHROOT_VARIABLES"
1224   [ -n "$SELECTED_PARTITIONS" ] && echo "SELECTED_PARTITIONS='$(sed "s,','\\\\'',g" <<<"${SELECTED_PARTITIONS}")'" >> "$CHROOT_VARIABLES"
1225   [ -n "$TARGET" ]              && echo "TARGET='$(sed "s,','\\\\'',g" <<<"${TARGET}")'"                           >> "$CHROOT_VARIABLES"
1226   [ -n "$UPGRADE_SYSTEM" ]      && echo "UPGRADE_SYSTEM='$(sed "s,','\\\\'',g" <<<"${UPGRADE_SYSTEM}")'"           >> "$CHROOT_VARIABLES"
1227   [ -n "$TARGET_UUID" ]         && echo "TARGET_UUID='$(sed "s,','\\\\'',g" <<<"${TARGET_UUID}")'"                 >> "$CHROOT_VARIABLES"
1228   [ -n "$TIMEZONE" ]            && echo "TIMEZONE='$(sed "s,','\\\\'',g" <<<"${TIMEZONE}")'"                       >> "$CHROOT_VARIABLES"
1229   [ -n "$TUNE2FS" ]             && echo "TUNE2FS='$(sed "s,','\\\\'',g" <<<"${TUNE2FS}")'"                         >> "$CHROOT_VARIABLES"
1230   [ -n "$VMSIZE" ]              && echo "VMSIZE='$(sed "s,','\\\\'',g" <<<"${VMSIZE}")'"                           >> "$CHROOT_VARIABLES"
1231
1232   cp $VERBOSE "${CONFFILES}"/chroot-script "${MNTPOINT}"/bin/chroot-script
1233   chmod 755 "${MNTPOINT}"/bin/chroot-script
1234   [ -d "$MNTPOINT"/etc/debootstrap/ ] || mkdir "$MNTPOINT"/etc/debootstrap/
1235
1236   # make sure we have our files for later use via chroot-script
1237   cp $VERBOSE "${CONFFILES}/config"           "${MNTPOINT}"/etc/debootstrap/
1238   # make sure we adjust the configuration variables accordingly:
1239   sed -i "s#RELEASE=.*#RELEASE=\"$RELEASE\"#" "${MNTPOINT}"/etc/debootstrap/config
1240   sed -i "s#TARGET=.*#TARGET=\"$TARGET\"#"    "${MNTPOINT}"/etc/debootstrap/config
1241   sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          "${MNTPOINT}"/etc/debootstrap/config
1242
1243   # install notes:
1244   if [ -n "$INSTALL_NOTES" ] ; then
1245      [ -r "$INSTALL_NOTES" ] && cp "$INSTALL_NOTES" "${MNTPOINT}"/etc/debootstrap/
1246   fi
1247
1248   # package selection:
1249   cp $VERBOSE "${_opt_packages:-$CONFFILES/packages}" \
1250     "${MNTPOINT}"/etc/debootstrap/packages
1251
1252   # debconf preseeding:
1253   _opt_debconf=${_opt_debconf:-$CONFFILES/debconf-selections}
1254   [ -f "${_opt_debconf}" ] && [ "$DEBCONF" = 'yes' ] && \
1255     cp $VERBOSE "${_opt_debconf}" "${MNTPOINT}"/etc/debootstrap/debconf-selections
1256
1257   # copy scripts that should be executed inside the chroot:
1258   _opt_chroot_scripts=${_opt_chroot_scripts:-$CONFFILES/chroot-scripts/}
1259   [ -d "$_opt_chroot_scripts" ] && [ "$CHROOT_SCRIPTS" = 'yes' ] && {
1260     mkdir -p "${MNTPOINT}"/etc/debootstrap/chroot-scripts
1261     cp -a $VERBOSE "${_opt_chroot_scripts}"/* "${MNTPOINT}"/etc/debootstrap/chroot-scripts/
1262   }
1263
1264   # notice: do NOT use $CHROOT_VARIABLES inside chroot but statically file instead!
1265   cp $VERBOSE "${CHROOT_VARIABLES}" "${MNTPOINT}"/etc/debootstrap/variables
1266
1267   cp $VERBOSE -a -L "${CONFFILES}"/extrapackages/ "${MNTPOINT}"/etc/debootstrap/
1268
1269   # make sure we can access network [relevant for cdebootstrap]
1270   [ -f "${MNTPOINT}"/etc/resolv.conf ] || cp $VERBOSE /etc/resolv.conf "${MNTPOINT}"/etc/resolv.conf
1271
1272   # provide system's /etc/hosts to the target:
1273   if ! [ -f "$MNTPOINT/etc/hosts" ] ; then
1274      cp $VERBOSE /etc/hosts "${MNTPOINT}"/etc/hosts
1275   fi
1276
1277   # setup default locales
1278   [ -n "$LOCALES" ] && cp $VERBOSE "${CONFFILES}"/locale.gen "${MNTPOINT}"/etc/locale.gen
1279
1280   # MAKEDEV is just a forking bomb crap, let's do it on our own instead :)
1281   ( cd "${MNTPOINT}"/dev && tar zxf /etc/debootstrap/devices.tar.gz )
1282
1283   # copy any existing files to chroot
1284   [ -d "${CONFFILES}"/bin   ] && cp $VERBOSE -a -L "${CONFFILES}"/bin/*   "${MNTPOINT}"/bin/
1285   [ -d "${CONFFILES}"/boot  ] && cp $VERBOSE -a -L "${CONFFILES}"/boot/*  "${MNTPOINT}"/boot/
1286   [ -d "${CONFFILES}"/etc   ] && cp $VERBOSE -a -L "${CONFFILES}"/etc/*   "${MNTPOINT}"/etc/
1287   [ -d "${CONFFILES}"/sbin  ] && cp $VERBOSE -a -L "${CONFFILES}"/sbin/*  "${MNTPOINT}"/sbin/
1288   [ -d "${CONFFILES}"/share ] && cp $VERBOSE -a -L "${CONFFILES}"/share/* "${MNTPOINT}"/share/
1289   [ -d "${CONFFILES}"/usr   ] && cp $VERBOSE -a -L "${CONFFILES}"/usr/*   "${MNTPOINT}"/usr/
1290   [ -d "${CONFFILES}"/var   ] && cp $VERBOSE -a -L "${CONFFILES}"/var/*   "${MNTPOINT}"/var/
1291
1292   # network setup
1293   DEFAULT_INTERFACES="# /etc/network/interfaces - generated by grml-debootstrap
1294
1295 # Include files from /etc/network/interfaces.d when using
1296 # ifupdown v0.7.44 or newer:
1297 #source-directory /etc/network/interfaces.d
1298
1299 auto lo
1300 iface lo inet loopback
1301
1302 allow-hotplug eth0
1303 iface eth0 inet dhcp
1304 "
1305
1306   if [ -n "$NOINTERFACES" ] ; then
1307     einfo "Not installing /etc/network/interfaces as requested via --nointerfaces option" ; eend 0
1308   elif [ -n "$USE_DEFAULT_INTERFACES" ] ; then
1309     einfo "Installing default /etc/network/interfaces as requested via --defaultinterfaces options."
1310     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1311     eend $?
1312   elif [ -n "$VIRTUAL" ] ; then
1313     einfo "Setting up Virtual Machine, installing default /etc/network/interfaces"
1314     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1315     eend $?
1316   elif [ -r /etc/network/interfaces ] ; then
1317     einfo "Copying /etc/network/interfaces from host to target system"
1318     cp $VERBOSE /etc/network/interfaces "${MNTPOINT}/etc/network/interfaces"
1319     eend $?
1320   else
1321     ewarn "Couldn't read /etc/network/interfaces, installing default /etc/network/interfaces"
1322     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1323     eend $?
1324   fi
1325
1326   # install config file providing some example entries
1327   if [ -r /etc/network/interfaces.examples -a ! -r "$MNTPOINT/etc/network/interfaces.examples" ] ; then
1328      cp /etc/network/interfaces.examples "$MNTPOINT/etc/network/interfaces.examples"
1329   fi
1330
1331   eend 0
1332 }
1333 # }}}
1334
1335 # execute all scripts in /etc/debootstrap/pre-scripts/ {{{
1336 execute_pre_scripts() {
1337    # make sure we have $MNTPOINT available for our scripts
1338    export MNTPOINT
1339    if [ -d "$_opt_pre_scripts" ] || [ "$PRE_SCRIPTS" = 'yes' ] ; then
1340       [ -d "$_opt_pre_scripts" ] && pre_scripts="$_opt_pre_scripts" || pre_scripts="$CONFFILES/pre-scripts/"
1341       for script in ${pre_scripts}/* ; do
1342          if [ -x "$script" ] ; then
1343             einfo "Executing pre-script $script"
1344             $script ; eend $?
1345          fi
1346       done
1347    fi
1348 }
1349 # }}}
1350
1351 # execute all scripts in /etc/debootstrap/scripts/ {{{
1352 execute_scripts() {
1353    # make sure we have $MNTPOINT available for our scripts
1354    export MNTPOINT
1355    if [ -d "$_opt_scripts" ] || [ "$SCRIPTS" = 'yes' ] ; then
1356       [ -d "$_opt_scripts" ] && scripts="$_opt_scripts" || scripts="$CONFFILES/scripts/"
1357       for script in ${scripts}/* ; do
1358          if [ -x "$script" ] ; then
1359             einfo "Executing script $script"
1360             $script ; eend $?
1361          fi
1362       done
1363    fi
1364 }
1365 # }}}
1366
1367 try_umount() {
1368   local tries=$1
1369   local mountpoint="$2"
1370
1371   for (( try=1; try<=tries; try++ )); do
1372     if [[ ${try} -eq ${tries} ]]; then
1373       # Last time, show errors this time
1374       umount "${mountpoint}" && return 0
1375     else
1376       # Not last time, hide errors until fatal
1377       if umount "${mountpoint}" 2>/dev/null ; then
1378         return 0
1379       else
1380         sleep 1
1381       fi
1382     fi
1383   done
1384   return 1  # Tried enough
1385 }
1386
1387 # execute chroot-script {{{
1388 chrootscript() {
1389   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
1390     mount_target
1391   fi
1392
1393   if ! [ -x "$MNTPOINT/bin/chroot-script" ] ; then
1394     eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
1395     eend 1
1396   else
1397     einfo "Executing chroot-script now"
1398     mount --bind /dev "$MNTPOINT"/dev
1399     mount --bind /dev/pts "$MNTPOINT"/dev/pts
1400     if [ "$DEBUG" = "true" ] ; then
1401       chroot "$MNTPOINT" /bin/sh -x /bin/chroot-script ; RC=$?
1402     else
1403       chroot "$MNTPOINT" /bin/chroot-script ; RC=$?
1404     fi
1405     try_umount 3 "$MNTPOINT"/dev/pts
1406     try_umount 3 "$MNTPOINT"/dev
1407     eend $RC
1408   fi
1409
1410   # finally get rid of chroot-script again, there's no good reason to
1411   # keep it on the installed system
1412   if grep -q GRML_CHROOT_SCRIPT_MARKER "${MNTPOINT}/bin/chroot-script" ; then
1413     einfo "Removing chroot-script again"
1414     rm -f "${MNTPOINT}/bin/chroot-script"
1415     eend $?
1416   else
1417     einfo "Keeping chroot-script as string GRML_CHROOT_SCRIPT_MARKER could not be found"
1418     eend 0
1419   fi
1420 }
1421 # }}}
1422
1423 # unmount $MNTPOINT {{{
1424 umount_chroot() {
1425
1426   # display installation notes:
1427   if [ -n "$INSTALL_NOTES" ] ; then
1428      [ -r "${MNTPOINT}/${INSTALL_NOTES}" ] && cat "${MNTPOINT}/${INSTALL_NOTES}"
1429   fi
1430
1431   if [ -n "$ISODIR" ] ; then
1432      if grep -q "$ISODIR" /proc/mounts ; then
1433         einfo "Unmount $MNTPOINT/$ISODIR"
1434         umount "$MNTPOINT/$ISODIR"
1435         eend $?
1436      fi
1437   fi
1438
1439   if grep -q "$MNTPOINT" /proc/mounts ; then
1440      if [ -n "$PARTITION" ] ; then
1441         einfo "Unmount $MNTPOINT"
1442         umount "$MNTPOINT"
1443         eend $?
1444      fi
1445   fi
1446 }
1447 # }}}
1448
1449 # execute filesystem check {{{
1450 fscktool() {
1451  if [ -n "$VIRTUAL" ] ; then
1452    einfo "Skipping filesystem check because we deploy a virtual machine."
1453    return 0
1454  fi
1455
1456  if [ "$FSCK" = 'yes' ] ; then
1457    [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
1458    einfo "Checking filesystem on $TARGET using $FSCKTOOL"
1459    "$FSCKTOOL" "$TARGET"
1460    eend $?
1461  fi
1462 }
1463 # }}}
1464
1465 # now execute all the functions {{{
1466 for i in prepare_vm mkfs tunefs mount_target debootstrap_system \
1467          preparechroot execute_pre_scripts chrootscript execute_scripts \
1468          umount_chroot finalize_vm fscktool ; do
1469     if stage "${i}" ; then
1470       if "$i" ; then
1471         stage "${i}" 'done' && rm -f "${STAGES}/${i}"
1472       else
1473         bailout 2 "$i"
1474       fi
1475     fi
1476 done
1477
1478 cleanup
1479 # }}}
1480
1481 # end dialog of autoinstallation {{{
1482 if [ -n "$AUTOINSTALL" ] ; then
1483    if dialog --title "${PN}" --pause "Finished execution of ${PN}.
1484 Automatically rebooting in 10 seconds.
1485
1486 Choose Cancel to skip rebooting." 10 60 10 ; then
1487      noeject noprompt reboot
1488   fi
1489 else
1490    einfo "Finished execution of ${PN}. Enjoy your Debian system." ; eend 0
1491 fi
1492 # }}}
1493
1494 ## END OF FILE #################################################################
1495 # vim: ai tw=100 expandtab foldmethod=marker shiftwidth=2